inject = require('../lib/inject')

class A
    foo: 1
class B
    bar: 2
class C extends A
    baz: 3
class D
    last: 4

@tests =
    inherits: (t) ->
        obj = new (inject.inherits B, A)
        t.ok obj instanceof A
        t.ok obj instanceof B
        t.equal obj.foo, 1
        t.equal obj.bar, 2
        t.done()

    inject: (t) ->
        obj = new (inject C, B)
        t.ok obj instanceof C
        t.ok obj instanceof B
        t.ok obj instanceof A
        t.equal obj.foo, 1
        t.equal obj.bar, 2
        t.equal obj.baz, 3
        t.done()

    multiple: (t) ->
        d = new (inject D, C, B, A)
        t.ok d instanceof D
        t.ok d instanceof C
        t.ok d instanceof B
        t.ok d instanceof A

        c = new C
        t.ok c instanceof B
        t.ok c not instanceof D

        b = new B
        t.ok b instanceof A
        t.ok b not instanceof C

        a = new A
        t.ok a not instanceof B

        t.done()
